// Copyright © 2017 Project Golan, all rights reserved.
#include "g_stage.h"
#include "g_object.h"
#include "g_player.h"
#include "r_draw.h"

#include <Doominati.h>

#include <stdio.h>

// Extern Functions ----------------------------------------------------------|

//
// GInit
//
void GInit(char const *resdecl)
{
   extern void R_ResDec_Load(char const *fname);

   printf("\n=====================\n"
          u8"オミ：影響の目    1.0\n"
          u8"Copyright © 2017 Project Golan, all rights reserved.\n\n");

   DGE_Renderer_SetVirtualRes(960, 720);

   printf("Loading resource declarations...\n");
   R_ResDec_Load(resdecl);

   printf("Loading object function table...\n");
   G_ObjDef_Init();
   G_ObjDef_loadFunc(G_Player_propC, G_Player_Think);

   printf("Loading object definitions...\n");
   G_ObjDef_Load("objdefs.dod");

   printf("Registering callbacks...\n");
   DGE_Callback_Register(DGE_CB_Draw,     (DGE_CallbackType)R_Draw);
   DGE_Callback_Register(DGE_CB_DrawPost, (DGE_CallbackType)R_DrawPost);

   printf("Ready.\n");
}

//
// main
//
[[__extern("asm")]] DGE_Callback
void main(void)
{
   GInit("resdecl.rd");
   G_Stage_LoadBase();
   G_Stage_Run(1);
}

// EOF
